Bug 830701 - glusterfs memory leak
glusterfs memory leak
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: unclassified (Show other bugs)
3.3.1
x86_64 Linux
high Severity high
: ---
: ---
Assigned To: Raghavendra Bhat
: Reopened
Depends On:
Blocks: 924423
  Show dependency treegraph
 
Reported: 2012-06-11 05:02 EDT by Ryszard Łach
Modified: 2013-07-24 13:17 EDT (History)
4 users (show)

See Also:
Fixed In Version: glusterfs-3.4.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 924423 (view as bug list)
Environment:
Last Closed: 2013-07-24 13:17:35 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Volume file (1.24 KB, application/octet-stream)
2012-06-11 05:02 EDT, Ryszard Łach
no flags Details
Glusterdump of glusterfs (324.48 KB, application/octet-stream)
2012-06-11 05:04 EDT, Ryszard Łach
no flags Details
GlusterFS Mem Leak Generator (1.34 KB, application/octet-stream)
2013-02-15 16:33 EST, Harshavardhana
no flags Details

  None (edit)
Description Ryszard Łach 2012-06-11 05:02:56 EDT
Created attachment 590863 [details]
Volume file

Description of problem:

Memory consumption of glusterfs still grows, about 500MB per day

Version-Release number of selected component (if applicable):

glusterfs-client  from backports.debian.org, 3.2.4-1~bpo60+1


Executing

echo 2 > /proc/sys/vm/drop_caches

does not reduce glusterfs process size.

I'm attaching glusterdump and volume-file.
Comment 1 Ryszard Łach 2012-06-11 05:04:43 EDT
Created attachment 590864 [details]
Glusterdump of glusterfs
Comment 2 Raghavendra Bhat 2012-12-04 05:08:30 EST
Ryszard,

Sorry for the delay, but we have put in some effort in memory leak fixes with later glusterfs releases. Can you please try upgrading to 3.3.1 and confirming the behavior?
Comment 3 Amar Tumballi 2012-12-20 02:34:16 EST
also you can you try if its fixed with latest qa releases? (3.4.0qa6)?
Comment 4 Ryszard Łach 2012-12-20 02:48:35 EST
We don't have memory leaks anymore after upgrade to Debian version 3.3.0-1 (newest commit in your changelog: 1b798491193add9cb296ce6817a6cbc2fdb9db34).

Cheers,

R.
Comment 5 Amar Tumballi 2012-12-20 03:47:59 EST
Thanks for confirming Ryszard.
Comment 6 Harshavardhana 2013-02-15 16:33:01 EST
Created attachment 697982 [details]
GlusterFS Mem Leak Generator

C program excerpt : ( repeated lock/unlock fcntl requests on a file descripton)
--------------------------------------------------------------------------------------------------------------------------
    printf( "Testing repeated lock/unlock fcntl requests on a file descriptor\n" );
    printf( "\n*** This program is running as an infinite loop, which should not cause filesystem failure ***\n" );
    for( ; ; ) {
        lck.l_type = F_WRLCK;
        if( fcntl( fd, F_SETLKW, &lck ) == -1) {
            printf( "error: failed to get exclusive lock on `%s';  errno %d\n", fl, errno );
            perror( "fcntl" );
            exit( 1 );
        }

        lck.l_type = F_UNLCK;
        if( fcntl( fd, F_SETLK, &lck ) == -1) {
            printf( "error: failed to release exclusive lock on `%s';  errno %d\n", fl, errno );
            perror( "fcntl" );
            exit( 1 );
        }
    }
--------------------------------------------------------------------------------------------------------------------------
Comment 7 Harshavardhana 2013-02-15 16:33:42 EST
Re-Opening this - still reproducible 

Version-Release number of selected component (if applicable):
-------------------------------------------------------------
glusterfs-3.3.1
glusterfs-3.4.0alpha
Comment 8 Raghavendra Bhat 2013-02-19 04:57:08 EST
http://review.gluster.org/4525 has been submitted ans accepted, which fixes the above leak issue.

Note You need to log in before you can comment on or make changes to this bug.